﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using SimpleLexer;

namespace SimpleLangLexerTest
{
    class Program
    {

        public static List<KeyValuePair<Tok, string>> getLexerOutput(Lexer l)
        {
            List<KeyValuePair<Tok, string>> result = new List<KeyValuePair<Tok, string>>();
            do
            {
                result.Add(new KeyValuePair<Tok, string>(l.LexKind, l.LexText));
                l.NextLexem();
            } while (l.LexKind != Tok.EOF);

            return result;
        }
        public static void Main()
        {
            /*string fileContents = @"begin 
id23 := 24;  
cycle ; 2 id258 id29 ; 
end";*/
            string fileContents = @" ts:=623 { 23 sa 3 }";
            TextReader inputReader = new StringReader(fileContents);
            Lexer l = new Lexer(inputReader);
            var list = getLexerOutput(l);
            try
            {
                do
                {
                    Console.WriteLine(l.TokToString(l.LexKind));
                    l.NextLexem();
                } while (l.LexKind != Tok.EOF);
            }
            catch (LexerException e)
            {
                Console.WriteLine("lexer error: " + e.Message);
            }
        }
    }
}