using System;
using System.IO;
using SimpleScanner;
using ScannerHelper;
using System.Collections.Generic;

namespace  GeneratedLexer
{
    
    public class LexerAddon
    {
        public Scanner myScanner;
        private byte[] inputText = new byte[255];

        public int idCount = 0;
        public double minIdLength = Int32.MaxValue;
        public double avgIdLength = 0;
        public double maxIdLength = 0;
        public int sumInt = 0;
        public double sumDouble = 0.0;
        public List<string> idsInComment = new List<string>();
        

        public LexerAddon(string programText)
        {
            
            using (StreamWriter writer = new StreamWriter(new MemoryStream(inputText)))
            {
                writer.Write(programText);
                writer.Flush();
            }
            
            MemoryStream inputStream = new MemoryStream(inputText);
            
            myScanner = new Scanner(inputStream);
        }

        public void Lex()
        {
            //         3.14 (  3,14    Culture)
            System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-US");

            int tok = 0;
            int all_length = 0;
            do {
                tok = myScanner.yylex();
                if ((Tok)tok == Tok.ID)
                {
                    idCount++;
                    var length = myScanner.TokToString((Tok)tok).Length - 3;
                    all_length += length;
                    if (length < minIdLength)
                        minIdLength = length;
                    if (length > maxIdLength)
                        maxIdLength = length;                   
                }
                else if ((Tok)tok == Tok.INUM)
                {
                    sumInt += myScanner.LexValueInt;
                }
                else if ((Tok)tok == Tok.RNUM)
                {
                    sumDouble += myScanner.LexValueDouble;
                }
                else if (tok == (int)Tok.EOF)
                {
                    avgIdLength = all_length /(double)idCount;
                    idsInComment = myScanner.idsInComment;
                    break;
                }
            } while (true);
        }
    }
}

