using System;
using System.IO;
using SimpleScanner;
using ScannerHelper;
using System.Collections.Generic;

namespace GeneratedLexer
{

    class mymain
    {
        static void Main(string[] args)
        {
            int cnt_id = 0;//- 
            double min_id_len = Double.MaxValue, max_id_len = 0; //,   
            double avg_id_len = 0; //  

            int sum_int = 0; //  
            double sum_d = 0; //  

            //         3.14 (  3,14    Culture)
            System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-US");

            var fname = @"..\..\a.txt";
            Console.WriteLine(File.ReadAllText(fname));
            Console.WriteLine("-------------------------");

            Scanner scanner = new Scanner(new FileStream(fname, FileMode.Open));

            int tok = 0;
            int all_length = 0;
            bool longcomment = false;
            List<string> idsInComment = new List<string>();
            do {
                tok = scanner.yylex();

                if ((Tok)tok == Tok.ID && !longcomment)
                {
                    cnt_id++;
                    var length = scanner.TokToString((Tok)tok).Length - 3;
                    all_length += length;
                    if (length < min_id_len)
                        min_id_len = length;
                    if (length > max_id_len)
                        max_id_len = length;
                }
                else if ((Tok)tok == Tok.ID && longcomment)
                {
                    var s = scanner.TokToString((Tok)tok);
                    var id = "";
                    for (int i = 3; i < s.Length; i++)
                    {
                        id += s[i];
                    }
                    idsInComment.Add(id);
                }
                else if ((Tok)tok == Tok.INUM)
                {
                    int sum = 0;
                    var k = scanner.TokToString((Tok)tok);
                    int index_begin = 0;
                    for (int i=0;i<k.Length;i++)
                    {
                        if (char.IsDigit(k[i]))
                        {
                            index_begin = i;
                            break;
                        }
                    }
                    for (int i = index_begin; i < k.Length; i++)
                    {
                        sum = sum * 10 + int.Parse(k[i].ToString());
                    }
                    sum_int += sum;
                }
                else if ((Tok)tok == Tok.RNUM)
                {
                    double sum = 0;
                    var k = scanner.TokToString((Tok)tok);
                    int index1 = 0;
                    int index2 = 0;
                    for (int i = 0; i < k.Length; i++)
                    {
                        if (char.IsDigit(k[i]))
                        {
                            index1 = i;
                            break;
                        }
                    }
                    for (int i = index1; i < k.Length; i++)
                    {
                        if (k[i]=='.')
                        {
                            index2 = i;
                            break;
                        }
                    }
                    for (int i = index1; i < index2; i++)
                    {
                        sum = sum * 10 + int.Parse(k[i].ToString());
                    }
                    double double_part = 0;
                    for(int i=index2+1;i<k.Length;i++)
                    {
                        double_part = double_part*10+int.Parse(k[i].ToString())/(Math.Pow(10,(i-index2)));
                    }

                    sum += double_part;
                    sum_d += sum;
                }
                else if ((Tok)tok == Tok.STRINGAP)
                {
                    var s = scanner.TokToString((Tok)tok);
                    int ind = 0;
                    for (int i = 0; i < s.Length; i++)
                    {
                        if (s[i] == '\'')
                        {
                            ind = i;
                            break;
                        }
                    }
                    var s2 = "";
                    for (int i = ind + 1; i < s.Length; i++)
                    {
                        if (s[i] == '\'')
                            break;
                        s2 += s[i];
                    }

                    int tok2 = 0;

                    byte[] inputText2 = new byte[255];

                    using (StreamWriter writer = new StreamWriter(new MemoryStream(inputText2)))
                    {
                        writer.Write(s2);
                        writer.Flush();
                    }

                    MemoryStream inputStream2 = new MemoryStream(inputText2);

                    var myScanner2 = new Scanner(inputStream2);

                    do
                    {
                        tok2 = myScanner2.yylex();
                        if ((Tok)tok2 == Tok.ID)
                        {
                            cnt_id++;
                        }
                        else if (tok2 == (int)Tok.EOF)
                        {
                            break;
                        }
                    } while (true);

                }
                if ((Tok)tok == Tok.LONGCOMMENT && !longcomment)
                {
                    longcomment = true;
                }
                else if ((Tok)tok == Tok.LONGCOMMENT && longcomment)
                {
                    longcomment = false;
                }
                if (tok == (int)Tok.EOF)
                {
                    avg_id_len = all_length / (double)cnt_id;
                    Console.WriteLine();
                    Console.WriteLine("number of id: {0:D}", cnt_id);
                    Console.WriteLine("average length of the id: {0:N}", avg_id_len);
                    Console.WriteLine("min length of the id: {0:D}", (int)min_id_len);
                    Console.WriteLine("max length of the id: {0:D}", (int)max_id_len);

                    Console.WriteLine();
                    Console.WriteLine("sum of int: {0:D}", sum_int);
                    Console.WriteLine("sum of double: {0:N}", sum_d);

                    Console.WriteLine();

                    break;
                }

                Console.WriteLine(scanner.TokToString((Tok)tok));
            } while (true);

            Console.ReadKey();
        }
    }
}

/*     1
  
  

begin ggg : ; := 7 99.9 5
1
ppp end

-------------------------
BEGIN
ID ggg
COLON
SEMICOLON
ASSIGN
INUM 7
RNUM 99.9
INUM 5
INUM 1
ID ppp
END

number of id: 0
average length of the id: NaN
min length of the id: 2147483647
min length of the id: 0

sum of int: 0
sum of double: 0.00

  

begin ggg : ; :+= 7 99.9 5
1
ppp end

-------------------------
BEGIN
ID ggg
COLON
SEMICOLON
COLON
(1,15): Iaecaanoiue neiaie +

number of id: 0
average length of the id: NaN
min length of the id: 2147483647
min length of the id: 0

sum of int: 0
sum of double: 0.00

()()()()()()()()()()()()()()()()

begin ggg : ; := 7 99.9 5 //
1
ppp end

-------------------------
BEGIN
ID ggg
COLON
SEMICOLON
ASSIGN
INUM 7
RNUM 99.9
INUM 5
(1,26): Iaecaanoiue neiaie /

number of id: 0
average length of the id: NaN
min length of the id: 2147483647
min length of the id: 0

sum of int: 0
sum of double: 0.00

()()()()()()()()()()()()()()()()

begin ggg : ; := 7 99.9 5
1
ppp end {}

-------------------------
BEGIN
ID ggg
COLON
SEMICOLON
ASSIGN
INUM 7
RNUM 99.9
INUM 5
INUM 1
ID ppp
END
(3,8): Iaecaanoiue neiaie {

number of id: 0
average length of the id: NaN
min length of the id: 2147483647
min length of the id: 0

sum of int: 0
sum of double: 0.00
   
 */
