%{
//      GPPGParser,   ,   gppg
    public Parser(AbstractScanner<int, LexLocation> scanner) : base(scanner) { }
%}

%output = SimpleYacc.cs

%namespace SimpleParser

%token BEGIN END CYCLE INUM RNUM ID ASSIGN SEMICOLON WHILE DO REPEAT UNTIL FOR TO IF THEN ELSE WRITE LEFT_BRACKET RIGHT_BRACKET VAR COMMA PLUS MINUS MULT DIVISION

%%

progr   : block
		;

stlist	: statement 
		| stlist SEMICOLON statement 
		;

idlist  : ident
		| idlist COMMA ident
		;

statement: assign
		| block  
		| cycle
		| while
		| repeat
		| for
		| if
		| write
		| var
		;

ident 	: ID 
		;
	
assign 	: ident ASSIGN expr 
		;

expr	: ident  
		| INUM 
		;

block	: BEGIN stlist END 
		;

cycle	: CYCLE expr statement 
		;
	
while   : WHILE expr DO statement
		;

repeat  : REPEAT stlist UNTIL expr
		;

for		: FOR ident ASSIGN expr TO expr DO statement
		;

if		: IF expr THEN statement
		| IF expr THEN statement ELSE statement
		;

write	: WRITE LEFT_BRACKET expr RIGHT_BRACKET
		;

var		: VAR idlist
		;

expr : T
     | expr PLUS T
     | expr MINUS T
     ;

T    : F
     | T MULT F
     | T DIVISION F
     ;

F    : ident
     | INUM 
     | LEFT_BRACKET expr RIGHT_BRACKET
     ;

%%
